<?php
namespace Ep\Woo\Form\Element;

use Zend\Form\Fieldset;

/**
 * Odabir atributa varijacije.
 *
 * @package Ep\Woo\Form\Element
 * @author Elektronika Perhoč <support@ep.hr>
 * @link https://bitbucket.org/elektronika-perhoc/ep-woocommerce
 */
class AttributeList extends Fieldset
{
    /** @var \WC_Product_Variable */
    protected $product;

    /**
     * @param \WC_Product_Variable $product
     */
    public function setProduct(\WC_Product_Variable $product): void
    {
        $this->elements = [];

        foreach ($product->get_variation_attributes() as $name => $values) {
            /** @var \WP_Term[] $terms */
            $terms = wc_get_product_terms($product->get_id(), $name, array(
                'fields' => 'all',
            ));

            $valueOptions = [];

            foreach ($terms as $term) {
                $valueOptions[$term->slug] = $term->name;
            }

            $elementName = sprintf('attribute_%s', $name);

            $this->add([
                'type' => 'woo.element.attribute',
                'name' => $elementName,
                'options' => [
                    'label' => wc_attribute_label($name),
                    'value_options' => $valueOptions,
                ],
                'attributes' => [
                    'data-attribute_name' => $elementName,
                ],
            ]);
        }
    }
}